<%
' ************************************ Z-ODP Code **********************************************	
' * Copyright Notice:
' & Copyright 2006 - Sevic Network, Inc (Zoran Sevic) - http://zodp.sevic.net
' * 
' * You may use and change this script as you see fit with the following conditions:
' * - You do not pass off this script as your own.
' * - You do not sell this script and only distribute it for free.
' * - Any changes made to this script to be freely shared with others
' * - You must leave this copyright notice intact even if you make changes to the script
' * - You are allowed to add additional copyrights from your own dirivative works of this script
' * - The link back at the bottom is not removed.
' *********************************************************************************************
Dim strOdpUrl, strOdpSearchUrl
Dim strOdpPath, strOdpCat, strOdpTitle
Dim objOdpXmlHttp
Dim strOdpHtml
Dim strOdpStatus
strOdpUrl = "http://dmoz.org"
strOdpSearchUrl = "http://search.dmoz.org/cgi-bin/search"
If request.QueryString("type") = "search" Then
	strOdpCat = request.QueryString("cat")
	strOdpTitle = replace(request.QueryString("cat"), "/", ":") & ":Search Directory"
Else
	strOdpCat = replace(replace(request.QueryString("path"), "/desc.html", ""), "/faq.html", "")
	strOdpTitle = replace(replace(strOdpCat, "/", ":"), "_", " ")
	Select Case request.QueryString("type")
	Case "desc"
		strOdpTitle = strOdpTitle & ":Category Description"
	Case "faq"
		strOdpTitle = strOdpTitle & ":Category FAQs"
	End Select
End If

	
'Response.CharSet = "UTF-8"

Function ZOdp ()
	If (request.QueryString("path") = "" OR request.QueryString("path") = "/") AND request.QueryString("type") <> "search" Then
		Call writeRoot("")
		Call writeFooter()
	Else
	'	Set objOdpXmlHttp = Server.CreateObject("Msxml2.XMLHTTP")
		Set objOdpXmlHttp = Server.CreateObject("Msxml2.ServerXMLHTTP")
		strOdpPath = request.QueryString("path")
		If request.QueryString("type") = "search" Then
			objOdpXmlHttp.open "GET", strOdpSearchUrl & "?" & request.ServerVariables("QUERY_STRING"), False
		Else
			'*** must replace the %2F to a / as the xml has a bug when you encode the url ***
			objOdpXmlHttp.open "GET", strOdpUrl & replace(Server.URLEncode(strOdpPath), "%2F", "/"), False
		End If
		objOdpXmlHttp.send
		strOdpStatus = objOdpXmlHttp.status
		If strOdpStatus = "200" Then
			strOdpHtml = objOdpXmlHttp.responseText
			' Removes all headers from the html
			strOdpHtml = leftStrip(strOdpHtml, "<body")
			strOdpHtml = leftStrip(strOdpHtml, ">")
			strOdpHtml = rightStrip(strOdpHtml, "</body>")
			strOdpHtml = leftStrip(strOdpHtml, "</center>")
			strOdpHtml = middlestrip(strOdpHtml, "<font", ">")
			strOdpHtml = replace(strOdpHtml, "</font>", "", 1, -1, 1)
			Select Case request.QueryString("type")
			Case "cat"
				Call parseCategory()
			Case "desc"
				Call parseDesc()
			Case "faq"
				Call parseFAQ()
			Case "search"
				Call parseSearch()
			Case "profile"
				Call parseEditorProfile()
			Case else

			End Select
			Call writeOdpPage()
		Else
			strOdpHtml = "ERROR Status:" & strOdpStatus
		End If
			
		Set objOdpXmlHttp = nothing 
		Call writeFooter()
	End If
End Function

Function leftStrip(html, beginTag)
	leftStrip = html
	If instr(lcase(html), lcase(beginTag)) Then 
		leftStrip = mid(html, instr(lcase(html), lcase(beginTag)) + len(beginTag))
	End If
End Function

Function leftStripRev(html, beginTag)
	leftStripRev = html
	if InstrRev(lcase(html), lcase(beginTag)) Then
		leftStripRev = mid(html, instrrev(lcase(html), lcase(beginTag)) + len(beginTag))
	End If
End Function


Function rightStrip(html, beginTag)
	rightStrip = html
	If instr(lcase(html), lcase(beginTag)) Then
		rightStrip = left(html, instr(lcase(html), lcase(beginTag))-1)
	End If
End Function

Function rightStripRev(html, beginTag)
	rightStripRev = html
	If instrRev(lcase(html), lcase(beginTag)) Then
		rightStripRev = left(html, instrrev(lcase(html), lcase(beginTag))-1)
	End If
End Function

Function middleStrip(html, beginTag, endTag)
' this routine basically nulls/strips everything from the a starting point to an ending point
' it uses a pretty complex routine, so change this at your own risk.
	middleStrip = html
	If instr(lcase(html), lcase(beginTag)) > 0 and instr(lcase(html), lcase(beginTag)) < instr(instr(lcase(html), lcase(beginTag)) + 1, lcase(html), lcase(endTag)) Then
		' loop until there are no more changes needed.
		While instr(lcase(middleStrip), lcase(beginTag)) > 0 and instr(lcase(middleStrip), lcase(beginTag)) < instr(instr(lcase(middleStrip), lcase(beginTag)) + 1, lcase(middleStrip), lcase(endTag))
			middleStrip = replace(middleStrip, mid(middleStrip, instr(lcase(middleStrip), lcase(beginTag)), ((instr(instr(lcase(middleStrip), lcase(beginTag)) + 1, lcase(middleStrip), lcase(endTag)) + len(endTag)) - instr(lcase(middleStrip), lcase(beginTag)))), "", 1, -1, 1)
		Wend
	End If
End Function

Function complexReplace(html, beginTag, endTag, replaceWith)
' this routine basically nulls/strips everything from the a starting point to an ending point
' it uses a pretty complex routine, so change this at your own risk.
	complexReplace = html
	If instr(lcase(html), lcase(beginTag)) > 0 and instr(lcase(html), lcase(beginTag)) < instr(instr(lcase(html), lcase(beginTag)) + 1, lcase(html), lcase(endTag)) Then
		' loop until there are no more changes needed.
		While instr(lcase(complexReplace), lcase(beginTag)) > 0 and instr(lcase(complexReplace), lcase(beginTag)) < instr(instr(lcase(complexReplace), lcase(beginTag)) + 1, lcase(complexReplace), lcase(endTag))
			complexReplace = replace(complexReplace, mid(complexReplace, instr(lcase(complexReplace), lcase(beginTag)), ((instr(instr(lcase(complexReplace), lcase(beginTag)) + 1, lcase(complexReplace), lcase(endTag)) + len(endTag)) - instr(lcase(complexReplace), lcase(beginTag)))), replaceWith, 1, -1, 1)
		Wend
	End If
End Function


Function breadCrumb()
End Function



Function parseCategory()
'	strOdpHtml = rightStripRev(strOdpHtml, "<table")

	strOdpHtml = rightStripRev(strOdpHtml, "<hr>")
	strOdpHtml = rightStripRev(strOdpHtml, "<hr>")

	strOdpHtml = middleStrip(strOdpHtml, "<a href=""/cgi-bin/apply.cgi", "</a>")
	strOdpHtml = replace(strOdpHtml, "href=""/profiles/", "href=""?type=profile&path=/profiles/", 1, -1, 1)
	strOdpHtml = replace(strOdpHtml, strOdpSearchUrl, "", 1, -1, 1)
	strOdpHtml = replace(strOdpHtml, "<input type=hidden name=cs", "<input type=hidden name=type value=""search"">" & vbnewline & "<input type=hidden name=cs", 1, -1, 1)
	strOdpHtml = replace(strOdpHtml, "img src=""/img/", "img src=""http://dmoz.org/img/", 1, -1, 1)
	strOdpHtml = replace(strOdpHtml, "href=""desc.html""", "href=""?type=desc&path=" & strOdpPath & "desc.html""", 1, -1, 1)
	strOdpHtml = replace(strOdpHtml, "href=""faq.html""", "href=""?type=faq&path=" & strOdpPath & "faq.html""", 1, -1, 1)
	strOdpHtml = replace(strOdpHtml, "href=""/", "href=""?type=cat&path=/", 1, -1, 1)
End Function

Function parseDesc()
	strOdpHtml = rightStripRev(strOdpHtml, "<table")
	' strips out the editor only charter
	strOdpHtml = middleStrip(strOdpHtml, "<a href=""/editors/charter.cgi", "more information</a> (editors only)")
	strOdpHtml = replace(strOdpHtml, "href=""/", "href=""?type=cat&path=/", 1, -1, 1)
	strOdpHtml = replace(strOdpHtml, "href=/", "href=?type=cat&path=/", 1, -1, 1)
	'editors sometimes put hard coded links into their diescription
	strOdpHtml = replace(strOdpHtml, "href=""http://dmoz.org", "href=""?type=cat&path=", 1, -1, 1)	
End Function

Function parseSearch()
	strOdpHtml = rightStripRev(strOdpHtml, "<table")
	'strOdpHtml = middleStrip(strOdpHtml, "<FORM", "</FORM>")
	strOdpHtml = replace(strOdpHtml, "<input type=""hidden"" name=""cat""", "<input type=""hidden"" name=type value=""search"">" & vbnewline & "<input type=""hidden"" name=""cat""", 1, -1, 1)
	strOdpHtml = middleStrip(strOdpHtml, "<A HREF=""/advanced_search.html"">", "</a>")
	strOdpHtml = middleStrip(strOdpHtml, "<A HREF=""/searchguide.html"">", "</a>")
	strOdpHtml = replace(strOdpHtml, "<a href=""search?", "<a href=""?type=search&", 1, -1, 1)
	strOdpHtml = replace(strOdpHtml, "ACTION=""search""", "ACTION=""""", 1, -1, 1)
	strOdpHtml = replace(strOdpHtml, "href=""" & strOdpUrl, "href=""?type=cat&path=", 1, -1, 1)	
End Function

Function parseFAQ()
	strOdpHtml = rightStripRev(strOdpHtml, "<table")
	strOdpHtml = rightStripRev(strOdpHtml, "<table")
	strOdpHtml = rightStripRev(strOdpHtml, "<table")
	strOdpHtml = leftStrip(strOdpHtml, "</table>")
	strOdpHtml = leftStrip(strOdpHtml, "</table>")
	strOdpHtml = replace(strOdpHtml, "href=""faq.html#", "href=""#", 1, -1, 1)
	strOdpHtml = complexReplace(strOdpHtml, "by <a href=""/profiles/", "</a>", "Last modified")
'	strOdpHtml = replace(strOdpHtml, "href=""/profiles/", "href=""?type=profile&path=/profiles/", 1, -1, 1)
	strOdpHtml = replace(strOdpHtml, "href=""/", "href=""?type=cat&path=/", 1, -1, 1)
	'editors sometimes put hard coded links into their diescription
	strOdpHtml = replace(strOdpHtml, "href=""http://dmoz.org", "href=""?type=cat&path=", 1, -1, 1)
	strOdpHtml = "<h3>"& strOdpTitle & "</h3>" & strOdpHtml 
End Function

Function parseEditorProfile()
	strOdpHtml = rightStripRev(strOdpHtml, "<table")
	' ---------------------------------------------------------------------------------------
	' Editor's sometimes use css in their profiles, this will tend to mess up your sites css,
	' layout, and colors. The 2 lines below strips it
	strOdpHtml = middleStrip(strOdpHtml, "<link rel", ">")
	strOdpHtml = middleStrip(strOdpHtml, "<style", "</style>")
	'---------------------------------------------------------------------------------------
	strOdpHtml = replace(strOdpHtml, "img src=""/img/", "img src=""http://dmoz.org/img/", 1, -1, 1)
	strOdpHtml = replace(strOdpHtml, "href=""/", "href=""?type=cat&path=/", 1, -1, 1)
'	strOdpHtml = replace(strOdpHtml, "href=""/", "href=""" & "?cat=/")
End Function

Function writeOdpPage ()
	Response.Write strOdpHtml
End Function


Function writeRoot(targerPage)
	Response.write("<table align=""center"" cellspacing=""4"" cellpadding=""4""><tr><td valign=top>" & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Arts/"">Arts</a><br><small>" & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Arts/Movies/"">Movies</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Arts/Television/"">Television</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Arts/Music/"">Music</a>...</small>" & vbNewline)
	Response.write("</td><td valign=top>" & vbNewline)
	Response.write("<b><a href=""" & targerPage & "?type=cat&path=/Business/"">Business</a></b><br><small>" & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Business/Employment/"">Jobs</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Business/Real_Estate/"">Real Estate</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Business/Investing/"">Investing</a>...</small>" & vbNewline)
	Response.write("</td><td valign=top>" & vbNewline)
	Response.write("<b><a href=""" & targerPage & "?type=cat&path=/Computers/"">Computers</a></b><br><small>" & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Computers/Internet/"">Internet</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Computers/Software/"">Software</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Computers/Hardware/"">Hardware</a>...</small>" & vbNewline)
	Response.write("</td></tr><tr><td valign=top>" & vbNewline)
	Response.write("<b><a href=""" & targerPage & "?type=cat&path=/Games/"">Games</a></b><br><small>" & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Games/Video_Games/"">Video Games</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Games/Roleplaying/"">RPGs</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Games/Gambling/"">Gambling</a>...</small>" & vbNewline)
	Response.write("</td><td valign=top>" & vbNewline)
	Response.write("<b><a href=""" & targerPage & "?type=cat&path=/Health/"">Health</a></b><br><small>" & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Health/Fitness/"">Fitness</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Health/Medicine/"">Medicine</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Health/Alternative/"">Alternative</a>...</small>" & vbNewline)
	Response.write("</td><td valign=top>" & vbNewline)
	Response.write("<b><a href=""" & targerPage & "?type=cat&path=/Home/"">Home</a></b><br><small>" & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Home/Family/"">Family</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Home/Consumer_Information/"">Consumers</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Home/Cooking/"">Cooking</a>...</small>" & vbNewline)
	Response.write("</td></tr><tr><td valign=top>" & vbNewline)
	Response.write("<b><a href=""" & targerPage & "?type=cat&path=/Kids_and_Teens/""><font color=""#ff0000"">K</font><font color=""339900"">i</font><font color=""#ff6600"">d</font><font color=""#0066ff"">s</font> and Teens</a></b><br><small>" & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Kids_and_Teens/Arts/"">Arts</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Kids_and_Teens/School_Time/"">School Time</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Kids_and_Teens/Teen_Life/"">Teen Life</a>...</small>" & vbNewline)
	Response.write("</td><td valign=top>" & vbNewline)
	Response.write("<b><a href=""" & targerPage & "?type=cat&path=/News/"">News</a></b><br><small>" & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/News/Media/"">Media</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/News/Newspapers/"">Newspapers</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/News/Weather/"">Weather</a>...</small>" & vbNewline)
	Response.write("</td><td valign=top>" & vbNewline)
	Response.write("<b><a href=""" & targerPage & "?type=cat&path=/Recreation/"">Recreation</a></b><br><small>" & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Recreation/Travel/"">Travel</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Recreation/Food/"">Food</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Recreation/Outdoors/"">Outdoors</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Recreation/Humor/"">Humor</a>...</small>" & vbNewline)
	Response.write("</td></tr><tr><td valign=top>" & vbNewline)
	Response.write("<b><a href=""" & targerPage & "?type=cat&path=/Reference/"">Reference</a></b><br><small>" & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Reference/Maps/"">Maps</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Reference/Education/"">Education</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Reference/Libraries/"">Libraries</a>...</small>" & vbNewline)
	Response.write("</td><td valign=top>" & vbNewline)
	Response.write("<b><a href=""" & targerPage & "?type=cat&path=/Regional/"">Regional</a></b><br><small>" & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Regional/North_America/United_States/"">US</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Regional/North_America/Canada/"">Canada</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Regional/Europe/United_Kingdom/"">UK</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Regional/Europe/"">Europe</a>...</small>" & vbNewline)
	Response.write("</td><td valign=top>" & vbNewline)
	Response.write("<b><a href=""" & targerPage & "?type=cat&path=/Science/"">Science</a></b><br><small>" & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Science/Biology/"">Biology</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Science/Social_Sciences/Psychology/"">Psychology</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Science/Physics/"">Physics</a>...</small>" & vbNewline)
	Response.write("</td></tr><tr><td valign=top>" & vbNewline)
	Response.write("<b><a href=""" & targerPage & "?type=cat&path=/Shopping/"">Shopping</a></b><br><small>" & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Shopping/Vehicles/Autos/"">Autos</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Shopping/Clothing/"">Clothing</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Shopping/Gifts/"">Gifts</a>...</small>" & vbNewline)
	Response.write("</td><td valign=top>" & vbNewline)
	Response.write("<b><a href=""" & targerPage & "?type=cat&path=/Society/"">Society</a></b><br><small>" & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Society/People/"">People</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Society/Religion_and_Spirituality/"">Religion</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Society/Issues/"">Issues</a>...</small>" & vbNewline)
	Response.write("</td><td valign=top>" & vbNewline)
	Response.write("<b><a href=""" & targerPage & "?type=cat&path=/Sports/"">Sports</a></b><br><small>" & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Sports/Baseball/"">Baseball</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Sports/Soccer/"">Soccer</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/Sports/Basketball/"">Basketball</a>...</small>" & vbNewline)
	Response.write("</td></tr>" & vbNewline)
	Response.write("<tr><td colspan=3 valign=top>" & vbNewline)
	Response.write("<b><a href=""" & targerPage & "?type=cat&path=/World/"">World</a></b><br><small>" & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/World/Deutsch/"">Deutsch</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/World/Espa%c3%b1ol/"">Espaol</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/World/Fran%c3%a7ais/"">Franais</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/World/Italiano/"">Italiano</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/World/Japanese/"">Japanese</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/World/Nederlands/"">Nederlands</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/World/Polska/"">Polska</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/World/Dansk/"">Dansk</a>," & vbNewline)
	Response.write("<a href=""" & targerPage & "?type=cat&path=/World/Svenska/"">Svenska</a>...</small>" & vbNewline)
	Response.write("</td></tr></table>" & vbNewline)

End Function

Function writeFooter ()
	Response.write("<hr>" & vbNewline)
	' ******** DO NOT DELETE - this must stay as per license agreement with ODP **********
	Response.write("<table border=""0"" bgcolor=""#336600"" cellpadding=""3"" cellspacing=""0"" align=""center""><tr><td>" & vbNewline)
	Response.write("<table width=""100%"" border=""0"" align=""center"" cellpadding=""2"" cellspacing=""0"">" & vbNewline)
	Response.write("<tr align=""center""><td><font color=""#FFFFFF"">Help build the largest human-edited directory on the web.</font></td>" & vbNewline)
	Response.write("</tr><tr bgcolor=""#CCCCCC"" align=""center""><td>" & vbNewline)
	Response.write("<a href=""http://dmoz.org/cgi-bin/add.cgi?where=" & strOdpPath & """>Submit a Site</a> -" & vbNewline)
	Response.write("<a href=""http://dmoz.org/about.html""><b>Open Directory Project</b></a> -" & vbNewline)
	Response.write("<a href=""http://dmoz.org/cgi-bin/apply.cgi?where=" & strOdpPath & """>Become an Editor</a>" & vbNewline)
	Response.write("</td></tr></table>" & vbNewline)
	Response.write("</td></tr></table>" & vbNewline)
	' *************************************************************************************
	
	' ***** DO NOT DELETE - the link back must stay to use this script ********************
	Response.Write("<p align=""center""><a href=""http://zodp.sevic.net/""><small><strong>Powered by Z-ODP</strong></small></a></p>")
	' *************************************************************************************
End Function


%>
